"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var http = require("http");

var https = require("https");

var JsonRpcServerFactory = require(".");

var HttpServerProtocol = require("./protocol/http");
/**
 * Creates instance of HttpServerFactory
 * @extends JsonRpcServerFactory
 */


var HttpServerFactory = /*#__PURE__*/function (_JsonRpcServerFactory) {
  _inherits(HttpServerFactory, _JsonRpcServerFactory);

  var _super = _createSuper(HttpServerFactory);

  /**
   *
   * In addition to the params and properties for [JsonRpcServerFactory]{@link JsonRpcServerFactory}
   * the WsServerProtocol has the following properties:
   *
   * @property {'http'|'https'} scheme The scheme to allow connections with
   * @property {file} key The private SSL key file
   * @property {file} cert The SSL certificate file
   */
  function HttpServerFactory(options) {
    var _this;

    _classCallCheck(this, HttpServerFactory);

    _this = _super.call(this, options);
    _this.scheme = _this.options.scheme || "http";
    _this.key = _this.options.key;
    _this.cert = _this.options.cert;
    _this.protocol = HttpServerProtocol;
    return _this;
  }
  /** @inheritdoc */


  _createClass(HttpServerFactory, [{
    key: "setServer",
    value: function setServer() {
      if (this.scheme === "http") {
        this.server = new http.Server();
      } else if (this.scheme === "https") {
        this.server = new https.Server({
          key: this.key,
          cert: this.cert
        });
      } else {
        throw Error("Invalid scheme");
      }
    }
    /** @inheritdoc */

  }, {
    key: "buildProtocol",
    value: function buildProtocol() {
      var _this2 = this;

      this.server.on("connection", function (client) {
        _this2.clientConnected(client);

        _this2.clients.push(client);

        client.on("close", function () {
          _this2.clientDisconnected(client);
        }); // maybe need .on('end') event listener?
      });
      this.server.on("request", function (request, response) {
        var pcol = new _this2.protocol(_this2, request, response, _this2.options.version, _this2.options.delimiter);
        pcol.clientConnected();
      });
    }
    /**
     * Called when client receives a `connection` event.
     *
     * @param {stream.Duplex} client Instance of `stream.Duplex`
     * @returns {stream.Duplex} Returns an instance of `stream.Duplex`
     */

  }, {
    key: "clientConnected",
    value: function clientConnected(client) {
      return client;
    }
    /**
     * Called when client disconnects from server.
     *
     * @param {stream.Duplex} client Instance of `stream.Duplex`
     * @returns {object|error} Returns an object of {host, port} for the given protocol instance, or {error}
     * if there was an error retrieving the client
     */

  }, {
    key: "clientDisconnected",
    value: function clientDisconnected(client) {
      return this.removeDisconnectedClient(client);
    }
    /**
     * Removes disconnected client from `this.clients` list
     *
     * @param {stream.Duplex} client Instance of `stream.Duplex`
     * @returns {object|error} Returns an object of {host, port} for the given protocol instance, or {error}
     * if there was an error retrieving the client
     */

  }, {
    key: "removeDisconnectedClient",
    value: function removeDisconnectedClient(client) {
      var clientIndex = this.clients.findIndex(function (c) {
        return c === client;
      });

      if (clientIndex === -1) {
        return {
          error: "Unknown client ".concat(JSON.stringify(client))
        };
      }

      var _this$clients$splice = this.clients.splice(clientIndex, 1),
          _this$clients$splice2 = _slicedToArray(_this$clients$splice, 1),
          disconnectedClient = _this$clients$splice2[0];

      return disconnectedClient;
    }
  }]);

  return HttpServerFactory;
}(JsonRpcServerFactory);

module.exports = HttpServerFactory;